Subject: Search path for fluid template files

Description

I'm currently working on a project where multiple extensions need to share some generic views, as well as be able to overwrite them
locally.

| have made a patch for fluid that should not break in BC, but add the option for the TemplateView class to scan multiple extensions
for view files.

Simply put | have added an "addExtensionSearchPath" method to TemplateView that appends extensions to a flat array (if it haven't
already been added)

| have also changed so the following methods has a new optional argument called "extension" to overwrite the normal behavior of just
calling "getControllerExtensionKey"

- getTemplateRootPath()
- getPartialRootPath()
- getLayoutRootPath()

The protected function expandGenericPathPattern has been updated to iterate the new extensionSearchPaths class property and
build search paths like before for each extension.

With the path applied you simple have to do the following in your controller to add a new search path
$this->view->addExtensionSearchPath($_YOUR_EXT_KEY);

The search paths is processed First In First Out (FIFO) style, so your current extension always takes precedence over any additional
searchable extensions added later in the request cycle.

This patch greatly improves the flexibility of the fluid rendering system, and helps keeping things DRY in your apps.

| have attached my patch to this ticket

History

#1 - 2010-07-22 13:05 - Sebastian Kurfuerst
- Priority changed from Must have to Could have

#2 - 2010-08-06 21:02 - Bastian Waidelich
- Category changed from Core to View

I'm not sure about this one to be honest.. | think, the template path resolution is already quite complex.

Usually you would add TS constants for the template paths and override them to reside in your fileadmin/template... folder anyways. And then you can
set them to the same path if you want to.

Have you tried to move reusable parts into partials?
#3 - 2010-11-10 10:44 - Lukas Riiegg

I'd say the ability to define template paths on a per plugin basis is a must have. Not being able to define and redefine template paths would severely
limit the flexibility of any extbase plugins. A simple (and common) application would be when an extension is applied multiple times across a site, but
with differing layouts and partials for each application. Limiting the root paths makes fluid an unattractive templating solution.

#4 - 2011-05-06 10:07 - Sebastian Kurfuerst

- Parent task set to #26658

#5 - 2011-05-06 10:08 - Sebastian Kurfuerst
- Parent task deleted (#26658)

#6 - 2011-05-06 10:08 - Sebastian Kurfuerst
- Tracker changed from Task to Feature

#7 - 2011-05-06 10:12 - Sebastian Kurfuerst
- Target version deleted (1.0 beta 2)

#8 - 2012-03-12 18:10 - Christian Miiller

- Status changed from New to Needs Feedback
- Has patch set to No

Does this still make sense? The discussion and code is v4 and | think for v4 Typoscript can do everything needed. FLOWS3 needs a different approach
anyway... So close this ticket?

Files

fluid_patch.diff 7.8 kB 2010-07-22 Christian Winther
